/*
 * Copyright (c) 2015 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.bsvrz.kex.tls.osi7.Osi7TelegramTest
 *
 * de.bsvrz.kex.tls.osi7.Osi7TelegramTest is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  de.bsvrz.kex.tls.osi7.Osi7TelegramTest is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with de.bsvrz.kex.tls.osi7.Osi7TelegramTest.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Diese Datei ist Teil von de.bsvrz.kex.tls.osi7.Osi7TelegramTest.
 *
 *  de.bsvrz.kex.tls.osi7.Osi7TelegramTest ist Freie Software: Sie knnen es unter den Bedingungen
 *  der GNU General Public License, wie von der Free Software Foundation,
 *  Version 3 der Lizenz oder (nach Ihrer Wahl) jeder spteren
 *  verffentlichten Version, weiterverbreiten und/oder modifizieren.
 *
 *  de.bsvrz.kex.tls.osi7.Osi7TelegramTest wird in der Hoffnung, dass es ntzlich sein wird, aber
 *  OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *  Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
 *  Siehe die GNU General Public License fr weitere Details.
 *
 *  Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 *  Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */

package de.bsvrz.kex.tls.osi7;

import de.bsvrz.sys.funclib.debug.Debug;
import junit.framework.*;

/**
 * @author HCK
 */

public class Osi7TelegramTest extends TestCase {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

	Osi7Telegram t1, t2, t3, t4, t5;

// ------------------------------------------------------------------------
// STATISCHE METHODEN
// ------------------------------------------------------------------------

	public static Test suite() {
		TestSuite suite = new TestSuite(Osi7TelegramTest.class);
		Debug.setLoggerLevel("DEFAULT", Debug.FINEST);
		Debug.setHandlerLevel("StdErr", Debug.ALL);

		return suite;
	}

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	public Osi7TelegramTest(java.lang.String testName) {
		super(testName);
	}

// ------------------------------------------------------------------------
// SONSTIGE METHODEN
// ------------------------------------------------------------------------

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testCountSingleTelegram() {
		Osi7Telegram t;
		byte[] data = new byte[9];
		data[4] = 4;

		try {
			data[3] = 1;
			t = new Osi7Telegram(123, data, false);
			data[3] = 0;
			t = new Osi7Telegram(123, data, false);
		}
		catch (IllegalOsi7TelegramStructureException e) {
			assertEquals("Osi7Telegramm enthlt 0 Einzeltelegramme -> ausserhalb des gltigen Bereichs von 1..46 Einzeltelegrammen!", e.getMessage());
		}

		try {
			data[3] = 46;
			t = new Osi7Telegram(123, data, false);
		}
		catch (Exception e) {
			// 3. Test mit 46 Einzeltelegrammen (schlgt fehlt, da Lnge Telegramm krzer Lnge der Einzeltelegramme.
			assertEquals("java.lang.ArrayIndexOutOfBoundsException: 9", e.getMessage());
		}

		try {
			data[3] = 47;
			t = new Osi7Telegram(123, data, false);
		}
		catch (IllegalOsi7TelegramStructureException e) {
			assertEquals("Osi7Telegramm enthlt 47 Einzeltelegramme -> ausserhalb des gltigen Bereichs von 1..46 Einzeltelegrammen!", e.getMessage());
			return;
		}

		fail("Fehler bei ungltiger Anzahl Einzeltelegramme (1..47) nicht erkannt!");
	}

	public void testGetOsi7Adress() {
		try {
			t1 = new Osi7Telegram(0, new byte[]{(byte) 0, (byte) 0, (byte) 0, (byte) 1, 4, 0, 0, 0, 0}, false);
			t2 = new Osi7Telegram(65793, new byte[]{(byte) 1, (byte) 1, (byte) 1, (byte) 1, 4, 0, 0, 0, 0}, false);
			t3 = new Osi7Telegram(8355711, new byte[]{(byte) 127, (byte) 127, (byte) 127, (byte) 1, 4, 0, 0, 0, 0}, false);
			t4 = new Osi7Telegram(8421504, new byte[]{(byte) 128, (byte) 128, (byte) 128, (byte) 1, 4, 0, 0, 0, 0}, false);
			t5 = new Osi7Telegram(16777215, new byte[]{(byte) 255, (byte) 255, (byte) 255, (byte) 1, 4, 0, 0, 0, 0}, false);
		}
		catch (Exception e) {
			System.err.println("Exeption: " + e);
			fail("Fehler beim Anlagen eines neuen Osi7Telegramms!");
		}
		assertEquals(0, t1.getOsi7Adress());
		assertEquals(65793, t2.getOsi7Adress());
		assertEquals(8355711, t3.getOsi7Adress());
		assertEquals(8421504, t4.getOsi7Adress());
		assertEquals(16777215, t5.getOsi7Adress());
	}

	public void testGetOsi7AdressHex() {
		try {
			t1 = new Osi7Telegram(0, new byte[]{(byte) 0, (byte) 0, (byte) 0, (byte) 1, 4, 0, 0, 0, 0}, false);
			t2 = new Osi7Telegram(65793, new byte[]{(byte) 1, (byte) 1, (byte) 1, (byte) 1, 4, 0, 0, 0, 0}, false);
			t3 = new Osi7Telegram(8355711, new byte[]{(byte) 127, (byte) 127, (byte) 127, (byte) 1, 4, 0, 0, 0, 0}, false);
			t4 = new Osi7Telegram(8421504, new byte[]{(byte) 128, (byte) 128, (byte) 128, (byte) 1, 4, 0, 0, 0, 0}, false);
			t5 = new Osi7Telegram(16777215, new byte[]{(byte) 255, (byte) 255, (byte) 255, (byte) 1, 4, 0, 0, 0, 0}, false);
		}
		catch (Exception e) {
			System.err.println("Exeption: " + e);
			fail("Fehler beim Anlagen eines neuen Osi7Telegramms!");
		}
		assertEquals("0", t1.getOsi7AdressHex());
		assertEquals("10101", t2.getOsi7AdressHex());
		assertEquals("7f7f7f", t3.getOsi7AdressHex());
		assertEquals("808080", t4.getOsi7AdressHex());
		assertEquals("ffffff", t5.getOsi7AdressHex());
	}

	public void testGetOsi7AdressLocCode() {
		try {
			t1 = new Osi7Telegram(0, new byte[]{(byte) 0, (byte) 0, (byte) 0, (byte) 1, 4, 0, 0, 0, 0}, false);
			t2 = new Osi7Telegram(65793, new byte[]{(byte) 1, (byte) 1, (byte) 1, (byte) 1, 4, 0, 0, 0, 0}, false);
			t3 = new Osi7Telegram(8355711, new byte[]{(byte) 127, (byte) 127, (byte) 127, (byte) 1, 4, 0, 0, 0, 0}, false);
			t4 = new Osi7Telegram(8421504, new byte[]{(byte) 128, (byte) 128, (byte) 128, (byte) 1, 4, 0, 0, 0, 0}, false);
			t5 = new Osi7Telegram(16777215, new byte[]{(byte) 255, (byte) 255, (byte) 255, (byte) 1, 4, 0, 0, 0, 0}, false);
		}
		catch (Exception e) {
			System.err.println("Exeption: " + e);
			fail("Fehler beim Anlagen eines neuen Osi7Telegramms!");
		}
		assertEquals("0-0", t1.getOsi7AdressLocCode());
		assertEquals("257-1", t2.getOsi7AdressLocCode());
		assertEquals("32639-127", t3.getOsi7AdressLocCode());
		assertEquals("32896-128", t4.getOsi7AdressLocCode());
		assertEquals("65535-255", t5.getOsi7AdressLocCode());
	}

	public void testGetSender() {
		try {
			t1 = new Osi7Telegram(0, new byte[]{(byte) 0, (byte) 0, (byte) 0, (byte) 1, 4, 0, 0, 0, 0}, false);
			t2 = new Osi7Telegram(65793, new byte[]{(byte) 1, (byte) 1, (byte) 1, (byte) 1, 4, 0, 0, 0, 0}, false);
			t3 = new Osi7Telegram(8355711, new byte[]{(byte) 127, (byte) 127, (byte) 127, (byte) 1, 4, 0, 0, 0, 0}, false);
			t4 = new Osi7Telegram(8421504, new byte[]{(byte) 128, (byte) 128, (byte) 128, (byte) 1, 4, 0, 0, 0, 0}, false);
			t5 = new Osi7Telegram(16777215, new byte[]{(byte) 255, (byte) 255, (byte) 255, (byte) 1, 4, 0, 0, 0, 0}, false);
		}
		catch (Exception e) {
			System.err.println("Exeption: " + e);
			fail("Fehler beim Anlagen eines neuen Osi7Telegramms!");
		}
		assertEquals(0, t1.getSender());
		assertEquals(65793, t2.getSender());
		assertEquals(8355711, t3.getSender());
		assertEquals(8421504, t4.getSender());
		assertEquals(16777215, t5.getSender());
	}

	public void testIllegalOsi7TelegramStructure() {
		try {
			byte[] data = new byte[8];
			data[3] = 1;
			data[4] = 4;
			new Osi7Telegram(123, data, false);
		}
		catch (IllegalOsi7TelegramStructureException e) {
			assertEquals("Osi7Telegramm-Header enthlt nur 8 Byte < Minimum von 9 Byte!", e.getMessage());
			return;
		}
		fail("Fehler bei zu kurzem Telegrammkopf nicht erkannt");
	}

	public void testOsi7TelegramConstruction() {
		try {
			t1 = new Osi7Telegram(271163, new byte[]{(byte) 0, (byte) 0, (byte) 0, (byte) 3, //Anzahl Einzeltelegramme
			                                         (byte) 4, //Lnge Einzeltelegramm
			                                         (byte) 0, (byte) 0, (byte) 0, (byte) 0, //FG, ID, JobNr, AnzDEBlcke
			                                         (byte) 4, //Lnge Einzeltelegramm
			                                         (byte) 0, (byte) 0, (byte) 0, (byte) 0, //FG, ID, JobNr, AnzDEBlcke
			                                         (byte) 4, //Lnge Einzeltelegramm
			                                         (byte) 0, (byte) 0, (byte) 0, (byte) 0}, //FG, ID, JobNr, AnzDEBlcke
			                                                                                  false);
		}
		catch (Exception e) {
			System.err.println("Exception: " + e);
			e.printStackTrace();
			fail("Fehler beim Anlagen eines neuen Osi7Telegramms!");
		}
	}
}

