/*
 * Copyright (c) 2015 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault
 *
 * de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Diese Datei ist Teil von de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault ist Freie Software: Sie knnen es unter den Bedingungen
 *  der GNU General Public License, wie von der Free Software Foundation,
 *  Version 3 der Lizenz oder (nach Ihrer Wahl) jeder spteren
 *  verffentlichten Version, weiterverbreiten und/oder modifizieren.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.NewRoutingDefault wird in der Hoffnung, dass es ntzlich sein wird, aber
 *  OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *  Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
 *  Siehe die GNU General Public License fr weitere Details.
 *
 *  Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 *  Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */

package de.bsvrz.kex.tls.osi7.conversion;

/**
Legt die Tabelle mit den Knotennummernpaaren (Alte OSI7-Adresse, Neue OSI7-Adresse) fest, bei denen beim Versand die
 * Zieladresse abweichend von der logisch adressieren Knotennummer ist. *
 * @author inovat
 * @author Dipl.-Ing. Hans Chrstian Kni (HCK)
 * @version $Revision$ / $Date$ / ($Author$)
 */

public class NewRoutingDefault {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Sonstige ---------------------------------------------------------------
	// Tabelle mit den Knotennummernpaaren (Alte OSI7-Adresse, Neue OSI7-Adresse)
	private static final int[][] _newRouting = {
	};

// ------------------------------------------------------------------------
// STATISCHE METHODEN
// ------------------------------------------------------------------------

	/**
	 * Gibt die Tabelle mit den Knotennummernpaaren (Alte OSI7-Adresse, Neue OSI7-Adresse) zurck, bei denen beim Versand
	 * die Zieladresse abweichend von der logisch adressieren Knotennummer ist.
	 *
	 * @return Die Tabelle mit den Knotennummernpaaren (Alte OSI7-Adresse, Neue OSI7-Adresse).
	 */
	public static int[][] getNewRouting() {
		return _newRouting;
	}
}