/*
 * Copyright (c) 2015 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault
 *
 * de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Diese Datei ist Teil von de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault ist Freie Software: Sie knnen es unter den Bedingungen
 *  der GNU General Public License, wie von der Free Software Foundation,
 *  Version 3 der Lizenz oder (nach Ihrer Wahl) jeder spteren
 *  verffentlichten Version, weiterverbreiten und/oder modifizieren.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.SendingOsi7AdressNullDefault wird in der Hoffnung, dass es ntzlich sein wird, aber
 *  OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *  Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
 *  Siehe die GNU General Public License fr weitere Details.
 *
 *  Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 *  Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */

package de.bsvrz.kex.tls.osi7.conversion;

/**
 * Legt die Liste der FG/Typ/ID Kombinationen fest, fr die DE-Blcke nicht mit der Osi7Adresse des Zielknotens sonderm
 * mit der Adresse 0 verschickt werden sollen. Wird i.d.R. bei der FG 254 fr das Setzen/Abrufen der Knotennummer und
 * weiterer spezielle Konfigurationstelegramme bentigt.
 *
 * @author inovat, innovative systeme - verkehr - tunnel - technik
 * @author Dipl.-Ing. Hans Christian Kni (HCK)
 * @version $Revision$ / $Date$ / ($Author$)
 */

public class SendingOsi7AdressNullDefault {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Sonstige ---------------------------------------------------------------
	// Filter fr FG / Typ / Id Kombinationen, bei denen das
	// Telegramm mit Knotennummer (00 00 00) gesendet werden
	// muss
	private static final int[][] _sendingOsi7AdressNull = {
			{254, 37, 19}, // Abruf Knotennummer
			{254, 37, 3}, // Senden Knotennummer
			{254, 152, 3}, // Abruf KRI-Aktionsparamter
			{254, 153, 3}, // Zuweisung KRI-Aktionsparamter
			{254, 162, 19}, // Abruf KRI-Buskonfiguration (einfach)
			{254, 162, 3}, // Senden KRI-Buskonfiguration (einfach)
			{254, 166, 19}, // Abruf KRI-Buskonfiguration
			{254, 166, 3}, // Senden KRI-Buskonfiguration
			{254, 168, 19}, // Abruf KRI-Telefonparameter
			{254, 168, 3} // Senden KRI-Telefonparameter
	};

// ------------------------------------------------------------------------
// STATISCHE METHODEN
// ------------------------------------------------------------------------

	/**
	 * Gibt die Tabelle mit den FG/Typ/Id Kombinationen zurck, bei denen De-Blcke mit Osi7Adresse = 0 vesandt werden
	 * sollen.
	 *
	 * @return Die Tabelle mit den FG/Typ/Id Kombinationen.
	 */
	public static int[][] getSendingOsi7AdressNull() {
		return _sendingOsi7AdressNull;
	}
}