/*
 * Copyright (c) 2015 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme
 *
 * de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Diese Datei ist Teil von de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme.
 *
 *  de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme ist Freie Software: Sie knnen es unter den Bedingungen
 *  der GNU General Public License, wie von der Free Software Foundation,
 *  Version 3 der Lizenz oder (nach Ihrer Wahl) jeder spteren
 *  verffentlichten Version, weiterverbreiten und/oder modifizieren.
 *
 *  de.bsvrz.kex.tls.osi7.testumgebung.TestSimulationEmpfangeneTelegramme wird in der Hoffnung, dass es ntzlich sein wird, aber
 *  OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *  Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
 *  Siehe die GNU General Public License fr weitere Details.
 *
 *  Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 *  Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */



package de.bsvrz.kex.tls.osi7.testumgebung;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.kex.tls.osi7.TlsApplicationLayer;
import de.bsvrz.sys.funclib.debug.Debug;

//~ JDK IMPORTE ===============================================================

import java.util.Date;

//~ KLASSEN ===================================================================

/**
 * ToDo: Kurzbeschreibung.
 * <p/>
 * ToDo: Langbeschreibung.
 *
 * @author inovat, innovative systeme - verkehr - tunnel - technik
 * @author Dipl.-Ing. Hans Christian Kni (HCK)
 * @version $Revision$ / $Date$ / ($Author$)
 */
public class TestSimulationEmpfangeneTelegramme extends Thread {

    /**
     * DebugLogger fr Debug-Ausgaben.
     */
    private static final Debug debug = Debug.getLogger();

    //~ FELDER ================================================================

    private TlsApplicationLayer _tlsApplicationLayer;

    //
    int[][]       eingangsDaten        = {                                               //
        { 12, -1, 4, -1, 86, 73 },                                                       // Fall 1: int qKfz, int qPkw, int qLkw, int vKfz, int vPkw, int vLkw
        { 12, -1, -1, -1, 86, 73 },                                                      // Fall 2
        { 12, -1, 4, -1, -1, 73 },                                                       // Fall 3
        { 12, -1, 4, -1, 86, -1 },                                                       // Fall 4
        { 12, -1, 4, -1, -1, -1 },                                                       // Fall 5
        { 12, -1, -1, -1, -1, 73 },                                                      // Fall 6
        { 12, -1, -1, -1, 86, -1 },                                                      // Fall 7
        { 12, -1, -1, -1, -1, -1 },                                                      // Fall 8
        { -1, -1, 4, -1, 86, 73 },                                                       // Fall 9
        { -1, -1, -1, -1, 86, 73 },                                                      // Fall 10
        { -1, -1, 4, -1, -1, 73 },                                                       // Fall 11
        { -1, -1, 4, -1, 86, -1 },                                                       // Fall 12
        { -1, -1, 4, -1, -1, -1 },                                                       // Fall 13
        { -1, -1, -1, -1, -1, 73 },                                                      // Fall 14
        { -1, -1, -1, -1, 86, -1 },                                                      // Fall 15
        { -1, -1, -1, -1, -1, -1 },                                                      // Fall 16
        { 9, -1, 14, -1, 82, 75 },                                                       // Fall 17
        { 9, -1, 14, -1, -1, 75 },                                                       // Fall 18
        { 9, -1, 14, -1, 82, -1 },                                                       // Fall 19
        { 9, -1, 14, -1, -1, -1 },                                                       // Fall 20
        { 0, -1, 6, -1, -1, 78 },                                                        // Fall 21
        { 0, -1, 6, -1, 84, -1 },                                                        // Fall 22
        { 0, -1, 6, -1, -1, -1 },                                                        // Fall 23
        { 0, -1, 6, -1, 84, 78 },                                                        // Fall 24
        { 0, -1, -1, -1, 84, 78 },                                                       // Fall 25
        { 0, -1, -1, -1, 84, -1 },                                                       // Fall 26
        { 0, -1, -1, -1, -1, 78 },                                                       // Fall 27
        { 0, -1, -1, -1, -1, -1 },                                                       // Fall 28
        { 10, -1, 0, -1, 90, -1 },                                                       // Fall 29
        { 10, -1, 0, -1, -1, 77 },                                                       // Fall 30
        { 10, -1, 0, -1, -1, -1 },                                                       // Fall 31
        { 10, -1, 0, -1, 90, 77 },                                                       // Fall 32
        { -1, -1, 0, -1, 90, 77 },                                                       // Fall 33
        { -1, -1, 0, -1, 90, -1 },                                                       // Fall 34
        { -1, -1, 0, -1, -1, 77 },                                                       // Fall 35
        { -1, -1, 0, -1, -1, -1 },                                                       // Fall 36
        { 8, -1, 8, -1, -1, 80 },                                                        // Fall 37
        { 8, -1, 8, -1, 95, 80 },                                                        // Fall 38
        { 8, -1, 8, -1, 95, -1 },                                                        // Fall 39
        { 8, -1, 8, -1, -1, -1 },                                                        // Fall 40
        { 0, -1, 0, -1, -1, -1 },                                                        // Fall 41
        { 0, -1, 0, -1, 99, -1 },                                                        // Fall 42
        { 0, -1, 0, -1, -1, 79 },                                                        // Fall 43
        { 0, -1, 0, -1, 99, 79 },                                                        // Fall 44
        { 3, -1, 2, -1, 0, 7 },                                                          // Fall 45
        { 3, -1, 1, -1, 6, 0 },                                                          // Fall 46
        { 3, -1, 2, -1, 0, 0 },                                                          // Fall 47
        { 3, -1, 1, -1, 0, 0 }                                                           // Fall 48
    };
    private int[] listeDeUfd16BitDaten = new int[] { 48, 49, 53, 54, 56, 57, 59, 60, 61, 62, 64, 65, 66, 67, 68, 69, 72 };
    private int[] listeDeUfd32BitDaten = new int[] { 82, 86, 87, 88, 89 };               // 73, 74, 75, 76, 77, 78, 79
    private int[] listeDeUfd8BitDaten  = new int[] { 50, 51, 52, 55, 58, 63, 70, 71, };  // 73, 74, 75, 76, 77, 78, 79

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    public TestSimulationEmpfangeneTelegramme(TlsApplicationLayer tlsApplicationLayer) {
        _tlsApplicationLayer = tlsApplicationLayer;
    }

    //~ METHODEN ==============================================================

    private byte[] betriebsParameter(int de, int periodenDauerSekunden) {

        // Empfangene Telegramme simulieren
        // FG 3, Umfelddaten
        // Knoten 2560003 - x271003
        // Typ 32 BetriebsParamster
        byte lowByte   = (byte) (periodenDauerSekunden & 0xFF);
        byte hightByte = (byte) ((periodenDauerSekunden & 0xFF00) >> 8);

        return new byte[] {
            (byte) 0x03, (byte) 0x10, (byte) 0x27,  // Knotennummer
            (byte) 0x01,                            // Anzahl Einzeltelegramme
            (byte) 10,                              // Lnge Einzeltelegramme (4 + 6)
            (byte) 3,                               // FG
            (byte) 3,                               // ID
            (byte) 0x11,                            // Jobnummer
            (byte) 1,                               // Anzahl DE-Blcke
            (byte) 5,                               // Lnge DE-Block
            (byte) de,                              // DE-Kanal
            (byte) 32,                              // Typ
            (byte) lowByte,                         // Anwendungsdaten
            (byte) hightByte,                       // Anwendungsdaten
            (byte) 1                                // Zyklische Meldungsabgabe
        };
    }

    private byte[] ergebnisMeldungUfd16BitDaten(int de) {

        // Empfangene Telegramme simulieren
        // FG 3, Umfelddaten
        // Knoten 2560003 - x271003
        // Typ 48 Lufttemperatur
        return new byte[] {
            (byte) 0x03, (byte) 0x10, (byte) 0x27,  // Knotennummer
            (byte) 0x01,                            // Anzahl Einzeltelegramme
            (byte) 9,                               // Lnge Einzeltelegramme (4 + 5)
            (byte) 3,                               // FG
            (byte) 4,                               // ID
            (byte) 0x11,                            // Jobnummer
            (byte) 1,                               // Anzahl DE-Blcke
            (byte) 4,                               // Lnge DE-Block
            (byte) de,                              // DE-Kanal
            (byte) de,                              // Typ
            (byte) 0,                               // Anwendungsdaten
            (byte) 0                                // Anwendungsdaten
        };
    }

    private byte[] ergebnisMeldungUfd32BitDaten(int de) {

        // Empfangene Telegramme simulieren
        // FG 3, Umfelddaten
        // Knoten 2560003 - x271003
        // Typ 48 Lufttemperatur
        return new byte[] {
            (byte) 0x03, (byte) 0x10, (byte) 0x27,  // Knotennummer
            (byte) 0x01,                            // Anzahl Einzeltelegramme
            (byte) 11,                              // Lnge Einzeltelegramme (4 + 7)
            (byte) 3,                               // FG
            (byte) 4,                               // ID
            (byte) 0x11,                            // Jobnummer
            (byte) 1,                               // Anzahl DE-Blcke
            (byte) 6,                               // Lnge DE-Block
            (byte) de,                              // DE-Kanal
            (byte) de,                              // Typ
            (byte) 0,                               // Anwendungsdaten
            (byte) 0,                               // Anwendungsdaten
            (byte) 0,                               // Anwendungsdaten
            (byte) 0                                // Anwendungsdaten
        };
    }

    private byte[] ergebnisMeldungUfd8BitDaten(int de) {

        // Empfangene Telegramme simulieren
        // FG 3, Umfelddaten
        // Knoten 2560003 - x271003
        // Typ 48 Lufttemperatur
        return new byte[] {
            (byte) 0x03, (byte) 0x10, (byte) 0x27,  // Knotennummer
            (byte) 0x01,                            // Anzahl Einzeltelegramme
            (byte) 8,                               // Lnge Einzeltelegramme (4 + 4)
            (byte) 3,                               // FG
            (byte) 4,                               // ID
            (byte) 0x11,                            // Jobnummer
            (byte) 1,                               // Anzahl DE-Blcke
            (byte) 3,                               // Lnge DE-Block
            (byte) de,                              // DE-Kanal
            (byte) de,                              // Typ
            (byte) 0                                // Anwendungsdaten
        };
    }

    public void run() {
        debug.info(String.format("%n=================================================================%n" + "TestSimulationEmpfangeneTelegramme gestartet...%n" + "=================================================================%n"));

        int de = 141;
        int qKfz;
        int qLkw;
        int vPkw;
        int vLkw;
        int tNetto;
        int b;
        int sKfz;
        int vgKfz;

        try {
            for (int t = 0; t < eingangsDaten.length; t++) {
                qKfz   = eingangsDaten[t][0] >=0 ? eingangsDaten[t][0] : 255;
                qLkw   = eingangsDaten[t][2] >=0 ? eingangsDaten[t][2] : 255;
                vPkw   = eingangsDaten[t][4] >=0 ? eingangsDaten[t][4] : 255;
                vLkw   = eingangsDaten[t][5] >=0 ? eingangsDaten[t][5] : 255;
                tNetto = 254;
                b      = 99;
                sKfz   = 50;
                vgKfz  = 50;
                _tlsApplicationLayer.dataReceived(0, verkehrDatenKurzZeit_Typ52_8Bit(de, qKfz, qLkw, vPkw, vLkw, tNetto, b, sKfz, vgKfz), false);
                sleep(1000);

	            qKfz   = eingangsDaten[t][0] >=0 ? eingangsDaten[t][0] : 0xffff;
	            qLkw   = eingangsDaten[t][2] >=0 ? eingangsDaten[t][2] : 0xffff;
	            vPkw   = eingangsDaten[t][4] >=0 ? eingangsDaten[t][4] : 255;
	            vLkw   = eingangsDaten[t][5] >=0 ? eingangsDaten[t][5] : 255;

	            _tlsApplicationLayer.dataReceived(0, verkehrDatenKurzZeit_Typ116_16Bit(de, qKfz,qLkw,vPkw,vLkw, tNetto, b, sKfz,vgKfz), false);
                 sleep(1000);
            }
        }
        catch (Exception e) {

            //
        }

        // try {
        //
        //// Betriebsparameter fr UFD setzen
        // for (int de : listeDeUfd16BitDaten) {
        // int periodenDauerSekunden = 60;
        //
        // _tlsApplicationLayer.dataReceived(2560003, betriebsParameter(de, periodenDauerSekunden), false);
        // }
        //
        // for (int de : listeDeUfd8BitDaten) {
        // int periodenDauerSekunden = 30;
        //
        // _tlsApplicationLayer.dataReceived(2560003, betriebsParameter(de, periodenDauerSekunden), false);
        // }
        //
        // for (int de : listeDeUfd32BitDaten) {
        // int periodenDauerSekunden = 120;
        //
        // _tlsApplicationLayer.dataReceived(2560003, betriebsParameter(de, periodenDauerSekunden), false);
        // }
        //
        //// Daten fr alle UFD Senden
        // for (int de : listeDeUfd16BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd16BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd8BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd8BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd32BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd32BitDaten(de), false);
        // }
        //
        // _tlsApplicationLayer.dataReceived(2560001, verkehrDatenKurzZeit(1), false);
        // sleep(15000);
        //
        // for (int de : listeDeUfd16BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd16BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd8BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd8BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd32BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd32BitDaten(de), false);
        // }
        //
        // _tlsApplicationLayer.dataReceived(2560001, verkehrDatenKurzZeit(1), false);
        // sleep(15000);
        //
        // for (int de : listeDeUfd16BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd16BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd8BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd8BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd32BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd32BitDaten(de), false);
        // }
        //
        // sleep(15000);
        //
        // for (int de : listeDeUfd16BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd16BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd8BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd8BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd32BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd32BitDaten(de), false);
        // }
        //
        // sleep(120000);
        //
        // for (int de : listeDeUfd16BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd16BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd8BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd8BitDaten(de), false);
        // }
        //
        // for (int de : listeDeUfd32BitDaten) {
        // _tlsApplicationLayer.dataReceived(2560003, ergebnisMeldungUfd32BitDaten(de), false);
        // }
        //
        // _tlsApplicationLayer.dataReceived(2560001, verkehrDatenKurzZeit(1), false);
        // }
        // catch (InterruptedException e) {
        //
        ////
        // }
    }

    private byte[] verkehrDatenKurzZeit(int de) {

        // Empfangene Telegramme simulieren
        // FG 1, Verkehrsdaten
        // Knoten 2560001 - x271001
        // Typ 48 Intervalldaten
        // Typ 49 Verkehrsdaten Version 0
        int  stunde, minute;
        Date date = new Date(System.currentTimeMillis());

        stunde = date.getHours();
        minute = date.getMinutes();

        return new byte[] {
            (byte) 0x01, (byte) 0x10, (byte) 0x27,  // Knotennummer
            (byte) 0x01,                            // Anzahl Einzeltelegramme
            (byte) 19,                              // Lnge Einzeltelegramme (4 + 8 + 7)
            (byte) 1,                               // FG
            (byte) 4,                               // ID
            (byte) 0x11,                            // Jobnummer
            (byte) 2,                               // Anzahl DE-Blcke

            // Typ 48 Intervalldaten
            (byte) 7,       // Lnge DE-Block
            (byte) 255,     // DE-Kanal
            (byte) 48,      // Typ
            (byte) stunde,  // Stunde
            (byte) minute,  // Minute
            (byte) 0,       // Sekunde
            (byte) 1,       // Kurzzeitdaten
            (byte) 4,       // Intervalllnge 4 = 1 Minute

            // Typ 49 Kurzzeitdaten Version 0
            (byte) 6,    // Lnge DE-Block
            (byte) de,   // DE-Kanal
            (byte) 49,   // Typ
            (byte) 1,    // Anwendungsdaten
            (byte) 2,    // Anwendungsdaten
            (byte) 100,  // Anwendungsdaten
            (byte) 80    // Anwendungsdaten
        };
    }

    // Test fr Umsetzung KEx-15 DUA
    private byte[] verkehrDatenKurzZeit_Typ116_16Bit(int de, int qKfz, int qLkw, int vPkw, int vLkw, int tNetto, int b, int sKfz, int vgKfz) {

	    // Empfangene Telegramme simulieren
	    // FG 1, Verkehrsdaten
	    // Knoten 200-6
	    // Typ 48 Intervalldaten
	    // Typ 52 Verkehrsdaten Version 3
	    int  stunde, minute;
	    Date date = new Date(System.currentTimeMillis());

	    stunde = date.getHours();
	    minute = date.getMinutes();

	    return new byte[] {
			    (byte) 6, (byte) 200, (byte) 0,  // Knotennummer
			    (byte) 0x01,                     // Anzahl Einzeltelegramme
			    (byte) 25,                       // Lnge Einzeltelegramme (4 + 8 + 13)
			    (byte) 1,                        // FG
			    (byte) 4,                        // ID
			    (byte) 0x11,                     // Jobnummer
			    (byte) 2,                        // Anzahl DE-Blcke

			    // Typ 48 Intervalldaten
			    (byte) 7,       // Lnge DE-Block
			    (byte) 255,     // DE-Kanal
			    (byte) 48,      // Typ
			    (byte) stunde,  // Stunde
			    (byte) minute,  // Minute
			    (byte) 0,       // Sekunde
			    (byte) 1,       // Kurzzeitdaten
			    (byte) 4,       // Intervalllnge 4 = 1 Minute

			    // Typ 52 Kurzzeitdaten Version 3
			    (byte) 12,      // Lnge DE-Block
			    (byte) de,      // DE-Kanal
			    (byte) 116,      // Typ
			    (byte) qKfz,    // qKfz --> hier einfach 2 Byte willkrlich belegt!!
			    (byte) qKfz,    // qKfz --> hier einfach 2 Byte willkrlich belegt!!
			    (byte) qLkw,    // qLkw --> hier einfach 2 Byte willkrlich belegt!!
			    (byte) qLkw,    // qLkw --> hier einfach 2 Byte willkrlich belegt!!
			    (byte) vPkw,    // vPkw
			    (byte) vLkw,    // vLkw
			    (byte) tNetto,  // tNetto
			    (byte) b,       // b
			    (byte) sKfz,    // sKfz
			    (byte) vgKfz    // vgKfz
	    };
    }

    // Test fr Umsetzung KEx-15 DUA
    private byte[] verkehrDatenKurzZeit_Typ52_8Bit(int de, int qKfz, int qLkw, int vPkw, int vLkw, int tNetto, int b, int sKfz, int vgKfz) {

        // Empfangene Telegramme simulieren
        // FG 1, Verkehrsdaten
        // Knoten 200-6
        // Typ 48 Intervalldaten
        // Typ 52 Verkehrsdaten Version 3
        int  stunde, minute;
        Date date = new Date(System.currentTimeMillis());

        stunde = date.getHours();
        minute = date.getMinutes();

        return new byte[] {
            (byte) 6, (byte) 200, (byte) 0,  // Knotennummer
            (byte) 0x01,                     // Anzahl Einzeltelegramme
            (byte) 23,                       // Lnge Einzeltelegramme (4 + 8 + 11)
            (byte) 1,                        // FG
            (byte) 4,                        // ID
            (byte) 0x11,                     // Jobnummer
            (byte) 2,                        // Anzahl DE-Blcke

            // Typ 48 Intervalldaten
            (byte) 7,       // Lnge DE-Block
            (byte) 255,     // DE-Kanal
            (byte) 48,      // Typ
            (byte) stunde,  // Stunde
            (byte) minute,  // Minute
            (byte) 0,       // Sekunde
            (byte) 1,       // Kurzzeitdaten
            (byte) 4,       // Intervalllnge 4 = 1 Minute

            // Typ 52 Kurzzeitdaten Version 3
            (byte) 10,      // Lnge DE-Block
            (byte) de,      // DE-Kanal
            (byte) 52,      // Typ
            (byte) qKfz,    // qKfz
            (byte) qLkw,    // qLkw
            (byte) vPkw,    // vPkw
            (byte) vLkw,    // vLkw
            (byte) tNetto,  // tNetto
            (byte) b,       // b
            (byte) sKfz,    // sKfz
            (byte) vgKfz    // vgKfz
        };
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 06.08.15
